Index: branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OOO_SRC/nemogcm.F90
===================================================================
--- branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OOO_SRC/nemogcm.F90	(revision 5891)
+++ branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OOO_SRC/nemogcm.F90	(revision 5901)
@@ -129,8 +129,9 @@
          &             nn_bench, nn_timing
       NAMELIST/namcfg/ cp_cfg, cp_cfz, jp_cfg, jpidta, jpjdta, jpkdta, jpiglo, jpjglo, &
-         &             jpizoom, jpjzoom, jperio
+         &             jpizoom, jpjzoom, jperio, ln_use_jattr
       !!----------------------------------------------------------------------
       !
       cltxt = ''
+      cxios_context = 'nemo'
       !
       !                             ! Open reference namelist and configuration namelist files
@@ -162,22 +163,22 @@
 #if defined key_iomput
       IF( Agrif_Root() ) THEN
-         IF( lk_cpl ) THEN
+         IF( lk_oasis ) THEN
             CALL cpl_init( ilocal_comm )                               ! nemo local communicator given by oasis
             CALL xios_initialize( "oceanx",local_comm=ilocal_comm )    ! send nemo communicator to xios
          ELSE
-            CALL  xios_initialize( "nemo",return_comm=ilocal_comm )    ! nemo local communicator given by xios
+            CALL  xios_initialize( "for_xios_mpi_id",return_comm=ilocal_comm )    ! nemo local communicator given by xios
          ENDIF
       ENDIF
       ENDIF
-      narea = mynode( cltxt, numnam_ref, numnam_cfg, numond , nstop, ilocal_comm )   ! Nodes selection
+      narea = mynode( cltxt, 'output.namelist.dyn', numnam_ref, numnam_cfg, numond , nstop, ilocal_comm )   ! Nodes selection
 #else
-      IF( lk_cpl ) THEN
+      IF( lk_oasis ) THEN
          IF( Agrif_Root() ) THEN
             CALL cpl_init( ilocal_comm )                               ! nemo local communicator given by oasis
          ENDIF
-         narea = mynode( cltxt, numnam_ref, numnam_cfg, numond , nstop, ilocal_comm )   ! Nodes selection (control print return in cltxt)
+         narea = mynode( cltxt, 'output.namelist.dyn', numnam_ref, numnam_cfg, numond , nstop, ilocal_comm )   ! Nodes selection (control print return in cltxt)
       ELSE
          ilocal_comm = 0
-         narea = mynode( cltxt, numnam_ref, numnam_cfg, numond , nstop )                ! Nodes selection (control print return in cltxt)
+         narea = mynode( cltxt, 'output.namelist.dyn', numnam_ref, numnam_cfg, numond , nstop )                ! Nodes selection (control print return in cltxt)
       ENDIF
 #endif
@@ -233,5 +234,5 @@
          WRITE(numout,*) '                       NEMO team'
          WRITE(numout,*) '            Ocean General Circulation Model'
-         WRITE(numout,*) '                  version 3.4  (2011) '
+         WRITE(numout,*) '                  version 3.6  (2015) '
          WRITE(numout,*)
          WRITE(numout,*)
Index: branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OOO_SRC/ooo_data.F90
===================================================================
--- branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OOO_SRC/ooo_data.F90	(revision 5891)
+++ branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OOO_SRC/ooo_data.F90	(revision 5901)
@@ -40,4 +40,5 @@
    CHARACTER(len=128) :: &
       & alt_file                       !: altimeter file
+   !! $Id$
 CONTAINS
    SUBROUTINE ooo_data_init( ld_cl4 )
Index: branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OOO_SRC/ooo_intp.F90
===================================================================
--- branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OOO_SRC/ooo_intp.F90	(revision 5891)
+++ branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OOO_SRC/ooo_intp.F90	(revision 5901)
@@ -16,4 +16,5 @@
    PUBLIC ooo_interp
 
+   !! $Id$
    CONTAINS
 
Index: branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OOO_SRC/ooo_read.F90
===================================================================
--- branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OOO_SRC/ooo_read.F90	(revision 5891)
+++ branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OOO_SRC/ooo_read.F90	(revision 5901)
@@ -22,4 +22,5 @@
    PUBLIC ooo_rea_dri
 
+   !! $Id$
 CONTAINS
    SUBROUTINE ooo_rea_dri(kfile)
Index: branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OOO_SRC/ooo_utils.F90
===================================================================
--- branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OOO_SRC/ooo_utils.F90	(revision 5891)
+++ branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OOO_SRC/ooo_utils.F90	(revision 5901)
@@ -10,4 +10,5 @@
    REAL(kind=dp), PARAMETER :: obfilldbl=99999.
 
+   !! $Id$
    CONTAINS
 
Index: branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OOO_SRC/ooo_write.F90
===================================================================
--- branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OOO_SRC/ooo_write.F90	(revision 5891)
+++ branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OOO_SRC/ooo_write.F90	(revision 5901)
@@ -29,4 +29,5 @@
    END INTERFACE
 
+   !! $Id$
    CONTAINS
 
Index: branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OPA_SRC/ASM/asmbkg.F90
===================================================================
--- branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OPA_SRC/ASM/asmbkg.F90	(revision 5891)
+++ branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OPA_SRC/ASM/asmbkg.F90	(revision 5901)
@@ -18,6 +18,4 @@
 
    !!----------------------------------------------------------------------
-   !!   'key_asminc' : Switch on the assimilation increment interface
-   !!----------------------------------------------------------------------
    !!   asm_bkg_wri  : Write out the background state
    !!   asm_trj_wri  : Write out the model state trajectory (used with 4D-Var)
@@ -27,6 +25,6 @@
    USE zdf_oce            ! Vertical mixing variables
    USE zdfddm             ! Double diffusion mixing parameterization
-   USE ldftra_oce         ! Lateral tracer mixing coefficient defined in memory
-   USE ldfslp             ! Slopes of neutral surfaces
+   USE ldftra             ! Lateral diffusion: eddy diffusivity coefficients
+   USE ldfslp             ! Lateral diffusion: slopes of neutral surfaces
    USE tradmp             ! Tracer damping
 #if defined key_zdftke
@@ -41,7 +39,4 @@
    USE asmpar             ! Parameters for the assmilation interface
    USE zdfmxl             ! mixed layer depth
-#if defined key_traldf_c2d
-   USE ldfeiv             ! eddy induced velocity coef.      (ldf_eiv routine)
-#endif
 #if defined key_lim2
    USE ice_2
@@ -155,10 +150,10 @@
             CALL iom_rstput( kt, nitdin_r, inum, 'sshn'   , sshn              )
 #if defined key_lim2 || defined key_lim3
-            IF(( nn_ice == 2 ) .OR. ( nn_ice == 3 )) THEN
-	       IF(ALLOCATED(frld)) THEN
-                  CALL iom_rstput( kt, nitdin_r, inum, 'iceconc', 1.0 - frld(:,:)   )
+            IF( nn_ice == 2  .OR.  nn_ice == 3 ) THEN
+	            IF( ALLOCATED(frld) ) THEN
+                  CALL iom_rstput( kt, nitdin_r, inum, 'iceconc', 1._wp - frld(:,:)   )
                ELSE
-		  CALL ctl_warn('Ice concentration not written to background as ice variable frld not allocated on this timestep')
-	       ENDIF
+		            CALL ctl_warn('Ice concentration not written to background as ice variable frld not allocated on this timestep')
+	            ENDIF
             ENDIF
 #endif
Index: branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90
===================================================================
--- branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90	(revision 5891)
+++ branches/2014/dev_r4621_NOC4_BDY_VERT_INTERP/NEMOGCM/NEMO/OPA_SRC/ASM/asminc.F90	(revision 5901)
@@ -14,6 +14,4 @@
 
    !!----------------------------------------------------------------------
-   !!   'key_asminc'   : Switch on the assimilation increment interface
-   !!----------------------------------------------------------------------
    !!   asm_inc_init   : Initialize the increment arrays and IAU weights
    !!   calc_date      : Compute the calendar date YYYYMMDD on a given step
@@ -28,5 +26,5 @@
    USE domvvl           ! domain: variable volume level
    USE oce              ! Dynamics and active tracers defined in memory
-   USE ldfdyn_oce       ! ocean dynamics: lateral physics
+   USE ldfdyn           ! lateral diffusion: eddy viscosity coefficients
    USE eosbn2           ! Equation of state - in situ and potential density
    USE zpshde           ! Partial step : Horizontal Derivative
@@ -56,14 +54,14 @@
     LOGICAL, PUBLIC, PARAMETER :: lk_asminc = .FALSE.  !: No assimilation increments
 #endif
-   LOGICAL, PUBLIC :: ln_bkgwri = .FALSE.      !: No output of the background state fields
-   LOGICAL, PUBLIC :: ln_asmiau = .FALSE.      !: No applying forcing with an assimilation increment
-   LOGICAL, PUBLIC :: ln_asmdin = .FALSE.      !: No direct initialization
-   LOGICAL, PUBLIC :: ln_trainc = .FALSE.      !: No tracer (T and S) assimilation increments
-   LOGICAL, PUBLIC :: ln_dyninc = .FALSE.      !: No dynamics (u and v) assimilation increments
-   LOGICAL, PUBLIC :: ln_sshinc = .FALSE.      !: No sea surface height assimilation increment
-   LOGICAL, PUBLIC :: ln_seaiceinc             !: No sea ice concentration increment
-   LOGICAL, PUBLIC :: ln_salfix = .FALSE.      !: Apply minimum salinity check
+   LOGICAL, PUBLIC :: ln_bkgwri     !: No output of the background state fields
+   LOGICAL, PUBLIC :: ln_asmiau     !: No applying forcing with an assimilation increment
+   LOGICAL, PUBLIC :: ln_asmdin     !: No direct initialization
+   LOGICAL, PUBLIC :: ln_trainc     !: No tracer (T and S) assimilation increments
+   LOGICAL, PUBLIC :: ln_dyninc     !: No dynamics (u and v) assimilation increments
+   LOGICAL, PUBLIC :: ln_sshinc     !: No sea surface height assimilation increment
+   LOGICAL, PUBLIC :: ln_seaiceinc  !: No sea ice concentration increment
+   LOGICAL, PUBLIC :: ln_salfix     !: Apply minimum salinity check
    LOGICAL, PUBLIC :: ln_temnofreeze = .FALSE. !: Don't allow the temperature to drop below freezing
-   INTEGER, PUBLIC :: nn_divdmp                !: Apply divergence damping filter nn_divdmp times
+   INTEGER, PUBLIC :: nn_divdmp     !: Apply divergence damping filter nn_divdmp times
 
    REAL(wp), PUBLIC, DIMENSION(:,:,:), ALLOCATABLE ::   t_bkg   , s_bkg      !: Background temperature and salinity
@@ -90,5 +88,4 @@
    !! * Substitutions
 #  include "domzgr_substitute.h90"
-#  include "ldfdyn_substitute.h90"
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
@@ -139,5 +136,5 @@
       ! Read Namelist nam_asminc : assimilation increment interface
       !-----------------------------------------------------------------------
-      ln_seaiceinc = .FALSE.
+      ln_seaiceinc   = .FALSE.
       ln_temnofreeze = .FALSE.
 
@@ -428,13 +425,11 @@
 
       IF ( ln_dyninc .AND. nn_divdmp > 0 ) THEN
-
-         CALL wrk_alloc(jpi,jpj,hdiv) 
-
-         DO  jt = 1, nn_divdmp
-
+         !
+         CALL wrk_alloc( jpi,jpj,   hdiv ) 
+         !
+         DO jt = 1, nn_divdmp
+            !
             DO jk = 1, jpkm1
-
                hdiv(:,:) = 0._wp
-
                DO jj = 2, jpjm1
                   DO ji = fs_2, fs_jpim1   ! vector opt.
@@ -444,30 +439,26 @@
                          + e1v(ji  ,jj  ) * fse3v(ji  ,jj  ,jk) * v_bkginc(ji  ,jj  ,jk)     &
                          - e1v(ji  ,jj-1) * fse3v(ji  ,jj-1,jk) * v_bkginc(ji  ,jj-1,jk)  )  &
-                         / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+                         / ( e1e2t(ji,jj) * fse3t(ji,jj,jk) )
                   END DO
                END DO
-
                CALL lbc_lnk( hdiv, 'T', 1. )   ! lateral boundary cond. (no sign change)
-
+               !
                DO jj = 2, jpjm1
                   DO ji = fs_2, fs_jpim1   ! vector opt.
-                     u_bkginc(ji,jj,jk) = u_bkginc(ji,jj,jk) + 0.2_wp * ( e1t(ji+1,jj)*e2t(ji+1,jj) * hdiv(ji+1,jj)   &
-                                                                        - e1t(ji  ,jj)*e2t(ji  ,jj) * hdiv(ji  ,jj) ) &
-                                                                      / e1u(ji,jj) * umask(ji,jj,jk) 
-                     v_bkginc(ji,jj,jk) = v_bkginc(ji,jj,jk) + 0.2_wp * ( e1t(ji,jj+1)*e2t(ji,jj+1) * hdiv(ji,jj+1)   &
-                                                                        - e1t(ji,jj  )*e2t(ji,jj  ) * hdiv(ji,jj  ) ) &
-                                                                      / e2v(ji,jj) * vmask(ji,jj,jk) 
+                     u_bkginc(ji,jj,jk) = u_bkginc(ji,jj,jk) + 0.2_wp * ( e1e2t(ji+1,jj) * hdiv(ji+1,jj)   &
+                        &                                               - e1e2t(ji  ,jj) * hdiv(ji  ,jj) ) &
+                        &                                             * r1_e1u(ji,jj) * umask(ji,jj,jk) 
+                     v_bkginc(ji,jj,jk) = v_bkginc(ji,jj,jk) + 0.2_wp * ( e1e2t(ji,jj+1) * hdiv(ji,jj+1)   &
+                        &                                               - e1e2t(ji,jj  ) * hdiv(ji,jj  ) ) &
+                        &                                             * r1_e2v(ji,jj) * vmask(ji,jj,jk) 
                   END DO
                END DO
-
             END DO
-
+            !
          END DO
-
-         CALL wrk_dealloc(jpi,jpj,hdiv) 
-
+         !
+         CALL wrk_dealloc( jpi,jpj,   hdiv ) 
+         !
       ENDIF
-
-
 
       !-----------------------------------------------------------------------
@@ -476,5 +467,5 @@
 
       IF ( ln_asmdin ) THEN
-
+         !
          ALLOCATE( t_bkg(jpi,jpj,jpk) )
          ALLOCATE( s_bkg(jpi,jpj,jpk) )
@@ -482,30 +473,29 @@
          ALLOCATE( v_bkg(jpi,jpj,jpk) )
          ALLOCATE( ssh_bkg(jpi,jpj)   )
-
-         t_bkg(:,:,:) = 0.0
-         s_bkg(:,:,:) = 0.0
-         u_bkg(:,:,:) = 0.0
-         v_bkg(:,:,:) = 0.0
-         ssh_bkg(:,:) = 0.0
-
+         !
+         t_bkg(:,:,:) = 0._wp
+         s_bkg(:,:,:) = 0._wp
+         u_bkg(:,:,:) = 0._wp
+         v_bkg(:,:,:) = 0._wp
+         ssh_bkg(:,:) = 0._wp
+         !
          !--------------------------------------------------------------------
          ! Read from file the background state at analysis time
          !--------------------------------------------------------------------
-
+         !
          CALL iom_open( c_asmdin, inum )
-
+         !
          CALL iom_get( inum, 'rdastp', zdate_bkg ) 
-        
+         !
          IF(lwp) THEN
             WRITE(numout,*) 
-            WRITE(numout,*) 'asm_inc_init : Assimilation background state valid at : ', &
-               &  NINT( zdate_bkg )
+            WRITE(numout,*) 'asm_inc_init : Assimilation background state valid at : ', NINT( zdate_bkg )
             WRITE(numout,*) '~~~~~~~~~~~~'
          ENDIF
-
+         !
          IF ( NINT( zdate_bkg ) /= iitdin_date ) &
             & CALL ctl_warn( ' Validity time of assimilation background state does', &
             &                ' not agree with Direct Initialization time' )
-
+         !
          IF ( ln_trainc ) THEN   
             CALL iom_get( inum, jpdom_autoglo, 'tn', t_bkg )
@@ -514,5 +504,5 @@
             s_bkg(:,:,:) = s_bkg(:,:,:) * tmask(:,:,:)
          ENDIF
-
+         !
          IF ( ln_dyninc ) THEN   
             CALL iom_get( inum, jpdom_autoglo, 'un', u_bkg )
@@ -521,12 +511,12 @@
             v_bkg(:,:,:) = v_bkg(:,:,:) * vmask(:,:,:)
          ENDIF
-        
+         !
          IF ( ln_sshinc ) THEN
             CALL iom_get( inum, jpdom_autoglo, 'sshn', ssh_bkg )
             ssh_bkg(:,:) = ssh_bkg(:,:) * tmask(:,:,1)
          ENDIF
-
+         !
          CALL iom_close( inum )
-
+         !
       ENDIF
       !
@@ -574,8 +564,6 @@
       ! If kt = kit000 - 1 then set the date to the restart date
       IF ( kt == kit000 - 1 ) THEN
-
          kdate = ndastp
          RETURN
-
       ENDIF
 
@@ -646,30 +634,27 @@
       !! ** Action  : 
       !!----------------------------------------------------------------------
-      INTEGER, INTENT(IN) :: kt               ! Current time step
-      !
-      INTEGER :: ji,jj,jk
-      INTEGER :: it
+      INTEGER, INTENT(IN) ::   kt   ! Current time step
+      !
+      INTEGER  :: ji, jj, jk
+      INTEGER  :: it
       REAL(wp) :: zincwgt  ! IAU weight for current time step
       REAL (wp), DIMENSION(jpi,jpj,jpk) :: fzptnz ! 3d freezing point values
       !!----------------------------------------------------------------------
-
+      !
       ! freezing point calculation taken from oc_fz_pt (but calculated for all depths) 
       ! used to prevent the applied increments taking the temperature below the local freezing point 
-
       DO jk = 1, jpkm1
         CALL eos_fzp( tsn(:,:,jk,jp_sal), fzptnz(:,:,jk), fsdept(:,:,jk) )
       END DO
-
-      IF ( ln_asmiau ) THEN
-
-         !--------------------------------------------------------------------
-         ! Incremental Analysis Updating
-         !--------------------------------------------------------------------
-
+         !
+         !                             !--------------------------------------
+      IF ( ln_asmiau ) THEN            ! Incremental Analysis Updating
+         !                             !--------------------------------------
+         !
          IF ( ( kt >= nitiaustr_r ).AND.( kt <= nitiaufin_r ) ) THEN
-
+            !
             it = kt - nit000 + 1
             zincwgt = wgtiau(it) / rdt   ! IAU weight for the current time step
-
+            !
             IF(lwp) THEN
                WRITE(numout,*) 
@@ -677,5 +662,5 @@
                WRITE(numout,*) '~~~~~~~~~~~~'
             ENDIF
-
+            !
             ! Update the tracer tendencies
             DO jk = 1, jpkm1
@@ -700,23 +685,19 @@
                ENDIF
             END DO
-
-         ENDIF
-
+            !
+         ENDIF
+         !
          IF ( kt == nitiaufin_r + 1  ) THEN   ! For bias crcn to work
             DEALLOCATE( t_bkginc )
             DEALLOCATE( s_bkginc )
          ENDIF
-
-
-      ELSEIF ( ln_asmdin ) THEN
-
-         !--------------------------------------------------------------------
-         ! Direct Initialization
-         !--------------------------------------------------------------------
-            
+         !                             !--------------------------------------
+      ELSEIF ( ln_asmdin ) THEN        ! Direct Initialization
+         !                             !--------------------------------------
+         !            
          IF ( kt == nitdin_r ) THEN
-
+            !
             neuler = 0  ! Force Euler forward step
-
+            !
             ! Initialize the now fields with the background + increment
             IF (ln_temnofreeze) THEN
@@ -745,18 +726,15 @@
 !!gm
 
-
-            IF( ln_zps .AND. .NOT. lk_c1d .AND. .NOT. ln_isfcav)      &
-               &  CALL zps_hde    ( kt, jpts, tsb, gtsu, gtsv,        &  ! Partial steps: before horizontal gradient
-               &                              rhd, gru , grv          )  ! of t, s, rd at the last ocean level
-            IF( ln_zps .AND. .NOT. lk_c1d .AND.       ln_isfcav)      &
-               &  CALL zps_hde_isf( nit000, jpts, tsb, gtsu, gtsv,    &    ! Partial steps for top cell (ISF)
-               &                                  rhd, gru , grv , aru , arv , gzu , gzv , ge3ru , ge3rv ,   &
-               &                           gtui, gtvi, grui, grvi, arui, arvi, gzui, gzvi, ge3rui, ge3rvi    ) ! of t, s, rd at the last ocean level
-
-#if defined key_zdfkpp
-            CALL eos( tsn, rhd, fsdept_n(:,:,:) )                      ! Compute rhd
-!!gm fabien            CALL eos( tsn, rhd )                      ! Compute rhd
-#endif
-
+            IF( ln_zps .AND. .NOT. lk_c1d ) THEN      ! Partial steps: before horizontal gradient
+               IF(ln_isfcav) THEN                        ! ocean cavities: top and bottom cells (ISF)
+                  CALL zps_hde_isf( nit000, jpts, tsb, gtsu, gtsv, gtui, gtvi,     &
+                     &                            rhd, gru , grv , aru , arv , gzu , gzv , ge3ru , ge3rv ,   &
+                     &                     grui, grvi, arui, arvi, gzui, gzvi, ge3rui, ge3rvi    )
+               ELSE                                      ! no ocean cavities: bottom cells
+                  CALL zps_hde    ( kt, jpts, tsb, gtsu, gtsv,        &  ! 
+                     &                        rhd, gru , grv          )  ! of t, s, rd at the last ocean level
+               ENDIF
+            ENDIF
+            !
             DEALLOCATE( t_bkginc )
             DEALLOCATE( s_bkginc )
@@ -767,5 +745,5 @@
       ENDIF
       ! Perhaps the following call should be in step
-      IF   ( ln_seaiceinc  )   CALL seaice_asm_inc ( kt )   ! apply sea ice concentration increment
+      IF ( ln_seaiceinc  )   CALL seaice_asm_inc ( kt )   ! apply sea ice concentration increment
       !
    END SUBROUTINE tra_asm_inc
@@ -788,23 +766,20 @@
       REAL(wp) :: zincwgt  ! IAU weight for current time step
       !!----------------------------------------------------------------------
-
-      IF ( ln_asmiau ) THEN
-
-         !--------------------------------------------------------------------
-         ! Incremental Analysis Updating
-         !--------------------------------------------------------------------
-
+      !
+      !                          !--------------------------------------------
+      IF ( ln_asmiau ) THEN      ! Incremental Analysis Updating
+         !                       !--------------------------------------------
+         !
          IF ( ( kt >= nitiaustr_r ).AND.( kt <= nitiaufin_r ) ) THEN
-
+            !
             it = kt - nit000 + 1
             zincwgt = wgtiau(it) / rdt   ! IAU weight for the current time step
-
+            !
             IF(lwp) THEN
                WRITE(numout,*) 
-               WRITE(numout,*) 'dyn_asm_inc : Dynamics IAU at time step = ', &
-                  &  kt,' with IAU weight = ', wgtiau(it)
+               WRITE(numout,*) 'dyn_asm_inc : Dynamics IAU at time step = ', kt,' with IAU weight = ', wgtiau(it)
                WRITE(numout,*) '~~~~~~~~~~~~'
             ENDIF
-
+            !
             ! Update the dynamic tendencies
             DO jk = 1, jpkm1
@@ -812,29 +787,26 @@
                va(:,:,jk) = va(:,:,jk) + v_bkginc(:,:,jk) * zincwgt
             END DO
-           
+            !
             IF ( kt == nitiaufin_r ) THEN
                DEALLOCATE( u_bkginc )
                DEALLOCATE( v_bkginc )
             ENDIF
-
-         ENDIF
-
-      ELSEIF ( ln_asmdin ) THEN 
-
-         !--------------------------------------------------------------------
-         ! Direct Initialization
-         !--------------------------------------------------------------------
-         
+            !
+         ENDIF
+         !                          !-----------------------------------------
+      ELSEIF ( ln_asmdin ) THEN     ! Direct Initialization
+         !                          !-----------------------------------------
+         !         
          IF ( kt == nitdin_r ) THEN
-
+            !
             neuler = 0                    ! Force Euler forward step
-
+            !
             ! Initialize the now fields with the background + increment
             un(:,:,:) = u_bkg(:,:,:) + u_bkginc(:,:,:)
             vn(:,:,:) = v_bkg(:,:,:) + v_bkginc(:,:,:)  
-
+            !
             ub(:,:,:) = un(:,:,:)         ! Update before fields
             vb(:,:,:) = vn(:,:,:)
- 
+            !
             DEALLOCATE( u_bkg    )
             DEALLOCATE( v_bkg    )
@@ -864,16 +836,14 @@
       REAL(wp) :: zincwgt  ! IAU weight for current time step
       !!----------------------------------------------------------------------
-
-      IF ( ln_asmiau ) THEN
-
-         !--------------------------------------------------------------------
-         ! Incremental Analysis Updating
-         !--------------------------------------------------------------------
-
+      !
+      !                             !-----------------------------------------
+      IF ( ln_asmiau ) THEN         ! Incremental Analysis Updating
+         !                          !-----------------------------------------
+         !
          IF ( ( kt >= nitiaustr_r ).AND.( kt <= nitiaufin_r ) ) THEN
-
+            !
             it = kt - nit000 + 1
             zincwgt = wgtiau(it) / rdt   ! IAU weight for the current time step
-
+            !
             IF(lwp) THEN
                WRITE(numout,*) 
@@ -882,5 +852,5 @@
                WRITE(numout,*) '~~~~~~~~~~~~'
             ENDIF
-
+            !
             ! Save the tendency associated with the IAU weighted SSH increment
             ! (applied in dynspg.*)
@@ -891,23 +861,18 @@
                DEALLOCATE( ssh_bkginc )
             ENDIF
-
-         ENDIF
-
-      ELSEIF ( ln_asmdin ) THEN
-
-         !--------------------------------------------------------------------
-         ! Direct Initialization
-         !--------------------------------------------------------------------
-
+            !
+         ENDIF
+         !                          !-----------------------------------------
+      ELSEIF ( ln_asmdin ) THEN     ! Direct Initialization
+         !                          !-----------------------------------------
+         !
          IF ( kt == nitdin_r ) THEN
-
-            neuler = 0                    ! Force Euler forward step
-
-            ! Initialize the now fields the background + increment
-            sshn(:,:) = ssh_bkg(:,:) + ssh_bkginc(:,:)  
-
-            ! Update before fields
-            sshb(:,:) = sshn(:,:)         
-
+            !
+            neuler = 0                                   ! Force Euler forward step
+            !
+            sshn(:,:) = ssh_bkg(:,:) + ssh_bkginc(:,:)   ! Initialize the now fields the background + increment
+            !
+            sshb(:,:) = sshn(:,:)                        ! Update before fields
+            !
             IF( lk_vvl ) THEN
                DO jk = 1, jpk
@@ -915,8 +880,8 @@
                END DO
             ENDIF
-
+            !
             DEALLOCATE( ssh_bkg    )
             DEALLOCATE( ssh_bkginc )
-
+            !
          ENDIF
          !
@@ -937,7 +902,5 @@
       !!
       !!----------------------------------------------------------------------
-      IMPLICIT NONE
-      !
-      INTEGER, INTENT(in)           ::   kt   ! Current time step
+      INTEGER, INTENT(in)           ::   kt       ! Current time step
       INTEGER, INTENT(in), OPTIONAL ::   kindic   ! flag for disabling the deallocation
       !
@@ -949,26 +912,23 @@
 #endif
       !!----------------------------------------------------------------------
-
-      IF ( ln_asmiau ) THEN
-
-         !--------------------------------------------------------------------
-         ! Incremental Analysis Updating
-         !--------------------------------------------------------------------
-
+      !
+      !                             !-----------------------------------------
+      IF ( ln_asmiau ) THEN         ! Incremental Analysis Updating
+         !                          !-----------------------------------------
+         !
          IF ( ( kt >= nitiaustr_r ).AND.( kt <= nitiaufin_r ) ) THEN
-
+            !
             it = kt - nit000 + 1
             zincwgt = wgtiau(it)      ! IAU weight for the current time step 
             ! note this is not a tendency so should not be divided by rdt (as with the tracer and other increments)
-
+            !
             IF(lwp) THEN
                WRITE(numout,*) 
-               WRITE(numout,*) 'seaice_asm_inc : sea ice conc IAU at time step = ', &
-                  &  kt,' with IAU weight = ', wgtiau(it)
+               WRITE(numout,*) 'seaice_asm_inc : sea ice conc IAU at time step = ', kt,' with IAU weight = ', wgtiau(it)
                WRITE(numout,*) '~~~~~~~~~~~~'
             ENDIF
-
+            !
             ! Sea-ice : LIM-3 case (to add)
-
+            !
 #if defined key_lim2
             ! Sea-ice : LIM-2 case
@@ -1008,22 +968,18 @@
 
 #if defined key_cice && defined key_asminc
-            ! Sea-ice : CICE case. Zero ice increment tendency into CICE
-            ndaice_da(:,:) = 0.0_wp
-#endif
-
-         ENDIF
-
-      ELSEIF ( ln_asmdin ) THEN
-
-         !--------------------------------------------------------------------
-         ! Direct Initialization
-         !--------------------------------------------------------------------
-
+            ndaice_da(:,:) = 0._wp        ! Sea-ice : CICE case. Zero ice increment tendency into CICE
+#endif
+
+         ENDIF
+         !                          !-----------------------------------------
+      ELSEIF ( ln_asmdin ) THEN     ! Direct Initialization
+         !                          !-----------------------------------------
+         !
          IF ( kt == nitdin_r ) THEN
-
+            !
             neuler = 0                    ! Force Euler forward step
-
+            !
             ! Sea-ice : LIM-3 case (to add)
-
+            !
 #if defined key_lim2
             ! Sea-ice : LIM-2 case.
@@ -1041,5 +997,5 @@
                zhicifinc(:,:) = (zhicifmin - hicif(:,:)) * zincwgt    
             ELSEWHERE
-               zhicifinc(:,:) = 0.0_wp
+               zhicifinc(:,:) = 0._wp
             END WHERE
             !
@@ -1050,20 +1006,20 @@
             ! seaice salinity balancing (to add)
 #endif
- 
+            !
 #if defined key_cice && defined key_asminc
             ! Sea-ice : CICE case. Pass ice increment tendency into CICE
            ndaice_da(:,:) = seaice_bkginc(:,:) / rdt
 #endif
-           IF ( .NOT. PRESENT(kindic) ) THEN
-              DEALLOCATE( seaice_bkginc )
-           END IF
-
+            IF ( .NOT. PRESENT(kindic) ) THEN
+               DEALLOCATE( seaice_bkginc )
+            END IF
+            !
          ELSE
-
+            !
 #if defined key_cice && defined key_asminc
-            ! Sea-ice : CICE case. Zero ice increment tendency into CICE 
-            ndaice_da(:,:) = 0.0_wp
-#endif
-         
+            ndaice_da(:,:) = 0._wp     ! Sea-ice : CICE case. Zero ice increment tendency into CICE
+
+#endif
+            !
          ENDIF
 
@@ -1142,7 +1098,7 @@
 !
 !#endif
-
+         !
       ENDIF
-
+      !
    END SUBROUTINE seaice_asm_inc
    
